// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: attributes.proto

#ifndef PROTOBUF_attributes_2eproto__INCLUDED
#define PROTOBUF_attributes_2eproto__INCLUDED

#include <string>

#include <google/protobuf/stubs/common.h>

#if GOOGLE_PROTOBUF_VERSION < 3005000
#error This file was generated by a newer version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please update
#error your headers.
#endif
#if 3005000 < GOOGLE_PROTOBUF_MIN_PROTOC_VERSION
#error This file was generated by an older version of protoc which is
#error incompatible with your Protocol Buffer headers.  Please
#error regenerate this file with a newer version of protoc.
#endif

#include <google/protobuf/io/coded_stream.h>
#include <google/protobuf/arena.h>
#include <google/protobuf/arenastring.h>
#include <google/protobuf/generated_message_table_driven.h>
#include <google/protobuf/generated_message_util.h>
#include <google/protobuf/metadata.h>
#include <google/protobuf/message.h>
#include <google/protobuf/repeated_field.h>  // IWYU pragma: export
#include <google/protobuf/extension_set.h>  // IWYU pragma: export
#include <google/protobuf/unknown_field_set.h>
#include "tango_enums.pb.h"
#include "value.pb.h"
#include "error.pb.h"
// @@protoc_insertion_point(includes)

namespace protobuf_attributes_2eproto {
// Internal implementation detail -- do not use these members.
struct TableStruct {
  static const ::google::protobuf::internal::ParseTableField entries[];
  static const ::google::protobuf::internal::AuxillaryParseTableField aux[];
  static const ::google::protobuf::internal::ParseTable schema[7];
  static const ::google::protobuf::internal::FieldMetadata field_metadata[];
  static const ::google::protobuf::internal::SerializationTable serialization_table[];
  static const ::google::protobuf::uint32 offsets[];
};
void AddDescriptors();
void InitDefaultsReadAttributeMessageImpl();
void InitDefaultsReadAttributeMessage();
void InitDefaultsReadAttributeReplyImpl();
void InitDefaultsReadAttributeReply();
void InitDefaultsDeviceAttributeImpl();
void InitDefaultsDeviceAttribute();
void InitDefaultsWriteAttributeMessageImpl();
void InitDefaultsWriteAttributeMessage();
void InitDefaultsWriteReplyImpl();
void InitDefaultsWriteReply();
void InitDefaultsAttributeDimensionImpl();
void InitDefaultsAttributeDimension();
void InitDefaultsTimeValImpl();
void InitDefaultsTimeVal();
inline void InitDefaults() {
  InitDefaultsReadAttributeMessage();
  InitDefaultsReadAttributeReply();
  InitDefaultsDeviceAttribute();
  InitDefaultsWriteAttributeMessage();
  InitDefaultsWriteReply();
  InitDefaultsAttributeDimension();
  InitDefaultsTimeVal();
}
}  // namespace protobuf_attributes_2eproto
namespace mascot {
class AttributeDimension;
class AttributeDimensionDefaultTypeInternal;
extern AttributeDimensionDefaultTypeInternal _AttributeDimension_default_instance_;
class DeviceAttribute;
class DeviceAttributeDefaultTypeInternal;
extern DeviceAttributeDefaultTypeInternal _DeviceAttribute_default_instance_;
class ReadAttributeMessage;
class ReadAttributeMessageDefaultTypeInternal;
extern ReadAttributeMessageDefaultTypeInternal _ReadAttributeMessage_default_instance_;
class ReadAttributeReply;
class ReadAttributeReplyDefaultTypeInternal;
extern ReadAttributeReplyDefaultTypeInternal _ReadAttributeReply_default_instance_;
class TimeVal;
class TimeValDefaultTypeInternal;
extern TimeValDefaultTypeInternal _TimeVal_default_instance_;
class WriteAttributeMessage;
class WriteAttributeMessageDefaultTypeInternal;
extern WriteAttributeMessageDefaultTypeInternal _WriteAttributeMessage_default_instance_;
class WriteReply;
class WriteReplyDefaultTypeInternal;
extern WriteReplyDefaultTypeInternal _WriteReply_default_instance_;
}  // namespace mascot
namespace mascot {

// ===================================================================

class ReadAttributeMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.ReadAttributeMessage) */ {
 public:
  ReadAttributeMessage();
  virtual ~ReadAttributeMessage();

  ReadAttributeMessage(const ReadAttributeMessage& from);

  inline ReadAttributeMessage& operator=(const ReadAttributeMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  ReadAttributeMessage(ReadAttributeMessage&& from) noexcept
    : ReadAttributeMessage() {
    *this = ::std::move(from);
  }

  inline ReadAttributeMessage& operator=(ReadAttributeMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const ReadAttributeMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const ReadAttributeMessage* internal_default_instance() {
    return reinterpret_cast<const ReadAttributeMessage*>(
               &_ReadAttributeMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    0;

  void Swap(ReadAttributeMessage* other);
  friend void swap(ReadAttributeMessage& a, ReadAttributeMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline ReadAttributeMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  ReadAttributeMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const ReadAttributeMessage& from);
  void MergeFrom(const ReadAttributeMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(ReadAttributeMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // string attributeName = 2;
  void clear_attributename();
  static const int kAttributeNameFieldNumber = 2;
  const ::std::string& attributename() const;
  void set_attributename(const ::std::string& value);
  #if LANG_CXX11
  void set_attributename(::std::string&& value);
  #endif
  void set_attributename(const char* value);
  void set_attributename(const char* value, size_t size);
  ::std::string* mutable_attributename();
  ::std::string* release_attributename();
  void set_allocated_attributename(::std::string* attributename);

  // @@protoc_insertion_point(class_scope:mascot.ReadAttributeMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  ::google::protobuf::internal::ArenaStringPtr attributename_;
  mutable int _cached_size_;
  friend struct ::protobuf_attributes_2eproto::TableStruct;
  friend void ::protobuf_attributes_2eproto::InitDefaultsReadAttributeMessageImpl();
};
// -------------------------------------------------------------------

class ReadAttributeReply : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.ReadAttributeReply) */ {
 public:
  ReadAttributeReply();
  virtual ~ReadAttributeReply();

  ReadAttributeReply(const ReadAttributeReply& from);

  inline ReadAttributeReply& operator=(const ReadAttributeReply& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  ReadAttributeReply(ReadAttributeReply&& from) noexcept
    : ReadAttributeReply() {
    *this = ::std::move(from);
  }

  inline ReadAttributeReply& operator=(ReadAttributeReply&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const ReadAttributeReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const ReadAttributeReply* internal_default_instance() {
    return reinterpret_cast<const ReadAttributeReply*>(
               &_ReadAttributeReply_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    1;

  void Swap(ReadAttributeReply* other);
  friend void swap(ReadAttributeReply& a, ReadAttributeReply& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline ReadAttributeReply* New() const PROTOBUF_FINAL { return New(NULL); }

  ReadAttributeReply* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const ReadAttributeReply& from);
  void MergeFrom(const ReadAttributeReply& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(ReadAttributeReply* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // .mascot.Error error = 2;
  bool has_error() const;
  void clear_error();
  static const int kErrorFieldNumber = 2;
  const ::mascot::Error& error() const;
  ::mascot::Error* release_error();
  ::mascot::Error* mutable_error();
  void set_allocated_error(::mascot::Error* error);

  // .mascot.DeviceAttribute data = 3;
  bool has_data() const;
  void clear_data();
  static const int kDataFieldNumber = 3;
  const ::mascot::DeviceAttribute& data() const;
  ::mascot::DeviceAttribute* release_data();
  ::mascot::DeviceAttribute* mutable_data();
  void set_allocated_data(::mascot::DeviceAttribute* data);

  // bool success = 1;
  void clear_success();
  static const int kSuccessFieldNumber = 1;
  bool success() const;
  void set_success(bool value);

  // @@protoc_insertion_point(class_scope:mascot.ReadAttributeReply)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::mascot::Error* error_;
  ::mascot::DeviceAttribute* data_;
  bool success_;
  mutable int _cached_size_;
  friend struct ::protobuf_attributes_2eproto::TableStruct;
  friend void ::protobuf_attributes_2eproto::InitDefaultsReadAttributeReplyImpl();
};
// -------------------------------------------------------------------

class DeviceAttribute : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.DeviceAttribute) */ {
 public:
  DeviceAttribute();
  virtual ~DeviceAttribute();

  DeviceAttribute(const DeviceAttribute& from);

  inline DeviceAttribute& operator=(const DeviceAttribute& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  DeviceAttribute(DeviceAttribute&& from) noexcept
    : DeviceAttribute() {
    *this = ::std::move(from);
  }

  inline DeviceAttribute& operator=(DeviceAttribute&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const DeviceAttribute& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const DeviceAttribute* internal_default_instance() {
    return reinterpret_cast<const DeviceAttribute*>(
               &_DeviceAttribute_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    2;

  void Swap(DeviceAttribute* other);
  friend void swap(DeviceAttribute& a, DeviceAttribute& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline DeviceAttribute* New() const PROTOBUF_FINAL { return New(NULL); }

  DeviceAttribute* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const DeviceAttribute& from);
  void MergeFrom(const DeviceAttribute& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(DeviceAttribute* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string name = 6;
  void clear_name();
  static const int kNameFieldNumber = 6;
  const ::std::string& name() const;
  void set_name(const ::std::string& value);
  #if LANG_CXX11
  void set_name(::std::string&& value);
  #endif
  void set_name(const char* value);
  void set_name(const char* value, size_t size);
  ::std::string* mutable_name();
  ::std::string* release_name();
  void set_allocated_name(::std::string* name);

  // string w_value = 17;
  void clear_w_value();
  static const int kWValueFieldNumber = 17;
  const ::std::string& w_value() const;
  void set_w_value(const ::std::string& value);
  #if LANG_CXX11
  void set_w_value(::std::string&& value);
  #endif
  void set_w_value(const char* value);
  void set_w_value(const char* value, size_t size);
  ::std::string* mutable_w_value();
  ::std::string* release_w_value();
  void set_allocated_w_value(::std::string* w_value);

  // .mascot.AttributeDimension r_dimension = 10;
  bool has_r_dimension() const;
  void clear_r_dimension();
  static const int kRDimensionFieldNumber = 10;
  const ::mascot::AttributeDimension& r_dimension() const;
  ::mascot::AttributeDimension* release_r_dimension();
  ::mascot::AttributeDimension* mutable_r_dimension();
  void set_allocated_r_dimension(::mascot::AttributeDimension* r_dimension);

  // .mascot.TimeVal time = 11;
  bool has_time() const;
  void clear_time();
  static const int kTimeFieldNumber = 11;
  const ::mascot::TimeVal& time() const;
  ::mascot::TimeVal* release_time();
  ::mascot::TimeVal* mutable_time();
  void set_allocated_time(::mascot::TimeVal* time);

  // .mascot.AttributeValue value = 13;
  bool has_value() const;
  void clear_value();
  static const int kValueFieldNumber = 13;
  const ::mascot::AttributeValue& value() const;
  ::mascot::AttributeValue* release_value();
  ::mascot::AttributeValue* mutable_value();
  void set_allocated_value(::mascot::AttributeValue* value);

  // .mascot.AttributeDimension w_dimension = 16;
  bool has_w_dimension() const;
  void clear_w_dimension();
  static const int kWDimensionFieldNumber = 16;
  const ::mascot::AttributeDimension& w_dimension() const;
  ::mascot::AttributeDimension* release_w_dimension();
  ::mascot::AttributeDimension* mutable_w_dimension();
  void set_allocated_w_dimension(::mascot::AttributeDimension* w_dimension);

  // int64 dim_x = 2;
  void clear_dim_x();
  static const int kDimXFieldNumber = 2;
  ::google::protobuf::int64 dim_x() const;
  void set_dim_x(::google::protobuf::int64 value);

  // int64 dim_y = 3;
  void clear_dim_y();
  static const int kDimYFieldNumber = 3;
  ::google::protobuf::int64 dim_y() const;
  void set_dim_y(::google::protobuf::int64 value);

  // .mascot.AttrDataFormat data_format = 1;
  void clear_data_format();
  static const int kDataFormatFieldNumber = 1;
  ::mascot::AttrDataFormat data_format() const;
  void set_data_format(::mascot::AttrDataFormat value);

  // bool has_failed = 4;
  void clear_has_failed();
  static const int kHasFailedFieldNumber = 4;
  bool has_failed() const;
  void set_has_failed(bool value);

  // bool is_empty = 5;
  void clear_is_empty();
  static const int kIsEmptyFieldNumber = 5;
  bool is_empty() const;
  void set_is_empty(bool value);

  // int64 nb_read = 7;
  void clear_nb_read();
  static const int kNbReadFieldNumber = 7;
  ::google::protobuf::int64 nb_read() const;
  void set_nb_read(::google::protobuf::int64 value);

  // int64 nb_written = 8;
  void clear_nb_written();
  static const int kNbWrittenFieldNumber = 8;
  ::google::protobuf::int64 nb_written() const;
  void set_nb_written(::google::protobuf::int64 value);

  // .mascot.AttrQuality quality = 9;
  void clear_quality();
  static const int kQualityFieldNumber = 9;
  ::mascot::AttrQuality quality() const;
  void set_quality(::mascot::AttrQuality value);

  // .mascot.CmdArgType type = 12;
  void clear_type();
  static const int kTypeFieldNumber = 12;
  ::mascot::CmdArgType type() const;
  void set_type(::mascot::CmdArgType value);

  // int64 w_dim_x = 14;
  void clear_w_dim_x();
  static const int kWDimXFieldNumber = 14;
  ::google::protobuf::int64 w_dim_x() const;
  void set_w_dim_x(::google::protobuf::int64 value);

  // int64 w_dim_y = 15;
  void clear_w_dim_y();
  static const int kWDimYFieldNumber = 15;
  ::google::protobuf::int64 w_dim_y() const;
  void set_w_dim_y(::google::protobuf::int64 value);

  // @@protoc_insertion_point(class_scope:mascot.DeviceAttribute)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr name_;
  ::google::protobuf::internal::ArenaStringPtr w_value_;
  ::mascot::AttributeDimension* r_dimension_;
  ::mascot::TimeVal* time_;
  ::mascot::AttributeValue* value_;
  ::mascot::AttributeDimension* w_dimension_;
  ::google::protobuf::int64 dim_x_;
  ::google::protobuf::int64 dim_y_;
  int data_format_;
  bool has_failed_;
  bool is_empty_;
  ::google::protobuf::int64 nb_read_;
  ::google::protobuf::int64 nb_written_;
  int quality_;
  int type_;
  ::google::protobuf::int64 w_dim_x_;
  ::google::protobuf::int64 w_dim_y_;
  mutable int _cached_size_;
  friend struct ::protobuf_attributes_2eproto::TableStruct;
  friend void ::protobuf_attributes_2eproto::InitDefaultsDeviceAttributeImpl();
};
// -------------------------------------------------------------------

class WriteAttributeMessage : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.WriteAttributeMessage) */ {
 public:
  WriteAttributeMessage();
  virtual ~WriteAttributeMessage();

  WriteAttributeMessage(const WriteAttributeMessage& from);

  inline WriteAttributeMessage& operator=(const WriteAttributeMessage& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  WriteAttributeMessage(WriteAttributeMessage&& from) noexcept
    : WriteAttributeMessage() {
    *this = ::std::move(from);
  }

  inline WriteAttributeMessage& operator=(WriteAttributeMessage&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const WriteAttributeMessage& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const WriteAttributeMessage* internal_default_instance() {
    return reinterpret_cast<const WriteAttributeMessage*>(
               &_WriteAttributeMessage_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    3;

  void Swap(WriteAttributeMessage* other);
  friend void swap(WriteAttributeMessage& a, WriteAttributeMessage& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline WriteAttributeMessage* New() const PROTOBUF_FINAL { return New(NULL); }

  WriteAttributeMessage* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const WriteAttributeMessage& from);
  void MergeFrom(const WriteAttributeMessage& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(WriteAttributeMessage* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // string deviceName = 1;
  void clear_devicename();
  static const int kDeviceNameFieldNumber = 1;
  const ::std::string& devicename() const;
  void set_devicename(const ::std::string& value);
  #if LANG_CXX11
  void set_devicename(::std::string&& value);
  #endif
  void set_devicename(const char* value);
  void set_devicename(const char* value, size_t size);
  ::std::string* mutable_devicename();
  ::std::string* release_devicename();
  void set_allocated_devicename(::std::string* devicename);

  // string attributeName = 2;
  void clear_attributename();
  static const int kAttributeNameFieldNumber = 2;
  const ::std::string& attributename() const;
  void set_attributename(const ::std::string& value);
  #if LANG_CXX11
  void set_attributename(::std::string&& value);
  #endif
  void set_attributename(const char* value);
  void set_attributename(const char* value, size_t size);
  ::std::string* mutable_attributename();
  ::std::string* release_attributename();
  void set_allocated_attributename(::std::string* attributename);

  // .mascot.AttributeValue value = 3;
  bool has_value() const;
  void clear_value();
  static const int kValueFieldNumber = 3;
  const ::mascot::AttributeValue& value() const;
  ::mascot::AttributeValue* release_value();
  ::mascot::AttributeValue* mutable_value();
  void set_allocated_value(::mascot::AttributeValue* value);

  // @@protoc_insertion_point(class_scope:mascot.WriteAttributeMessage)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::internal::ArenaStringPtr devicename_;
  ::google::protobuf::internal::ArenaStringPtr attributename_;
  ::mascot::AttributeValue* value_;
  mutable int _cached_size_;
  friend struct ::protobuf_attributes_2eproto::TableStruct;
  friend void ::protobuf_attributes_2eproto::InitDefaultsWriteAttributeMessageImpl();
};
// -------------------------------------------------------------------

class WriteReply : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.WriteReply) */ {
 public:
  WriteReply();
  virtual ~WriteReply();

  WriteReply(const WriteReply& from);

  inline WriteReply& operator=(const WriteReply& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  WriteReply(WriteReply&& from) noexcept
    : WriteReply() {
    *this = ::std::move(from);
  }

  inline WriteReply& operator=(WriteReply&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const WriteReply& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const WriteReply* internal_default_instance() {
    return reinterpret_cast<const WriteReply*>(
               &_WriteReply_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    4;

  void Swap(WriteReply* other);
  friend void swap(WriteReply& a, WriteReply& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline WriteReply* New() const PROTOBUF_FINAL { return New(NULL); }

  WriteReply* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const WriteReply& from);
  void MergeFrom(const WriteReply& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(WriteReply* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // .mascot.Error error = 2;
  bool has_error() const;
  void clear_error();
  static const int kErrorFieldNumber = 2;
  const ::mascot::Error& error() const;
  ::mascot::Error* release_error();
  ::mascot::Error* mutable_error();
  void set_allocated_error(::mascot::Error* error);

  // bool success = 1;
  void clear_success();
  static const int kSuccessFieldNumber = 1;
  bool success() const;
  void set_success(bool value);

  // @@protoc_insertion_point(class_scope:mascot.WriteReply)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::mascot::Error* error_;
  bool success_;
  mutable int _cached_size_;
  friend struct ::protobuf_attributes_2eproto::TableStruct;
  friend void ::protobuf_attributes_2eproto::InitDefaultsWriteReplyImpl();
};
// -------------------------------------------------------------------

class AttributeDimension : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.AttributeDimension) */ {
 public:
  AttributeDimension();
  virtual ~AttributeDimension();

  AttributeDimension(const AttributeDimension& from);

  inline AttributeDimension& operator=(const AttributeDimension& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  AttributeDimension(AttributeDimension&& from) noexcept
    : AttributeDimension() {
    *this = ::std::move(from);
  }

  inline AttributeDimension& operator=(AttributeDimension&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const AttributeDimension& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const AttributeDimension* internal_default_instance() {
    return reinterpret_cast<const AttributeDimension*>(
               &_AttributeDimension_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    5;

  void Swap(AttributeDimension* other);
  friend void swap(AttributeDimension& a, AttributeDimension& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline AttributeDimension* New() const PROTOBUF_FINAL { return New(NULL); }

  AttributeDimension* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const AttributeDimension& from);
  void MergeFrom(const AttributeDimension& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(AttributeDimension* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // int64 dim_x = 1;
  void clear_dim_x();
  static const int kDimXFieldNumber = 1;
  ::google::protobuf::int64 dim_x() const;
  void set_dim_x(::google::protobuf::int64 value);

  // int64 dim_y = 2;
  void clear_dim_y();
  static const int kDimYFieldNumber = 2;
  ::google::protobuf::int64 dim_y() const;
  void set_dim_y(::google::protobuf::int64 value);

  // @@protoc_insertion_point(class_scope:mascot.AttributeDimension)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::int64 dim_x_;
  ::google::protobuf::int64 dim_y_;
  mutable int _cached_size_;
  friend struct ::protobuf_attributes_2eproto::TableStruct;
  friend void ::protobuf_attributes_2eproto::InitDefaultsAttributeDimensionImpl();
};
// -------------------------------------------------------------------

class TimeVal : public ::google::protobuf::Message /* @@protoc_insertion_point(class_definition:mascot.TimeVal) */ {
 public:
  TimeVal();
  virtual ~TimeVal();

  TimeVal(const TimeVal& from);

  inline TimeVal& operator=(const TimeVal& from) {
    CopyFrom(from);
    return *this;
  }
  #if LANG_CXX11
  TimeVal(TimeVal&& from) noexcept
    : TimeVal() {
    *this = ::std::move(from);
  }

  inline TimeVal& operator=(TimeVal&& from) noexcept {
    if (GetArenaNoVirtual() == from.GetArenaNoVirtual()) {
      if (this != &from) InternalSwap(&from);
    } else {
      CopyFrom(from);
    }
    return *this;
  }
  #endif
  static const ::google::protobuf::Descriptor* descriptor();
  static const TimeVal& default_instance();

  static void InitAsDefaultInstance();  // FOR INTERNAL USE ONLY
  static inline const TimeVal* internal_default_instance() {
    return reinterpret_cast<const TimeVal*>(
               &_TimeVal_default_instance_);
  }
  static PROTOBUF_CONSTEXPR int const kIndexInFileMessages =
    6;

  void Swap(TimeVal* other);
  friend void swap(TimeVal& a, TimeVal& b) {
    a.Swap(&b);
  }

  // implements Message ----------------------------------------------

  inline TimeVal* New() const PROTOBUF_FINAL { return New(NULL); }

  TimeVal* New(::google::protobuf::Arena* arena) const PROTOBUF_FINAL;
  void CopyFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void MergeFrom(const ::google::protobuf::Message& from) PROTOBUF_FINAL;
  void CopyFrom(const TimeVal& from);
  void MergeFrom(const TimeVal& from);
  void Clear() PROTOBUF_FINAL;
  bool IsInitialized() const PROTOBUF_FINAL;

  size_t ByteSizeLong() const PROTOBUF_FINAL;
  bool MergePartialFromCodedStream(
      ::google::protobuf::io::CodedInputStream* input) PROTOBUF_FINAL;
  void SerializeWithCachedSizes(
      ::google::protobuf::io::CodedOutputStream* output) const PROTOBUF_FINAL;
  ::google::protobuf::uint8* InternalSerializeWithCachedSizesToArray(
      bool deterministic, ::google::protobuf::uint8* target) const PROTOBUF_FINAL;
  int GetCachedSize() const PROTOBUF_FINAL { return _cached_size_; }
  private:
  void SharedCtor();
  void SharedDtor();
  void SetCachedSize(int size) const PROTOBUF_FINAL;
  void InternalSwap(TimeVal* other);
  private:
  inline ::google::protobuf::Arena* GetArenaNoVirtual() const {
    return NULL;
  }
  inline void* MaybeArenaPtr() const {
    return NULL;
  }
  public:

  ::google::protobuf::Metadata GetMetadata() const PROTOBUF_FINAL;

  // nested types ----------------------------------------------------

  // accessors -------------------------------------------------------

  // int64 tv_nsec = 1;
  void clear_tv_nsec();
  static const int kTvNsecFieldNumber = 1;
  ::google::protobuf::int64 tv_nsec() const;
  void set_tv_nsec(::google::protobuf::int64 value);

  // int64 tv_sec = 2;
  void clear_tv_sec();
  static const int kTvSecFieldNumber = 2;
  ::google::protobuf::int64 tv_sec() const;
  void set_tv_sec(::google::protobuf::int64 value);

  // int64 tv_usec = 3;
  void clear_tv_usec();
  static const int kTvUsecFieldNumber = 3;
  ::google::protobuf::int64 tv_usec() const;
  void set_tv_usec(::google::protobuf::int64 value);

  // @@protoc_insertion_point(class_scope:mascot.TimeVal)
 private:

  ::google::protobuf::internal::InternalMetadataWithArena _internal_metadata_;
  ::google::protobuf::int64 tv_nsec_;
  ::google::protobuf::int64 tv_sec_;
  ::google::protobuf::int64 tv_usec_;
  mutable int _cached_size_;
  friend struct ::protobuf_attributes_2eproto::TableStruct;
  friend void ::protobuf_attributes_2eproto::InitDefaultsTimeValImpl();
};
// ===================================================================


// ===================================================================

#ifdef __GNUC__
  #pragma GCC diagnostic push
  #pragma GCC diagnostic ignored "-Wstrict-aliasing"
#endif  // __GNUC__
// ReadAttributeMessage

// string deviceName = 1;
inline void ReadAttributeMessage::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& ReadAttributeMessage::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.ReadAttributeMessage.deviceName)
  return devicename_.GetNoArena();
}
inline void ReadAttributeMessage::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.ReadAttributeMessage.deviceName)
}
#if LANG_CXX11
inline void ReadAttributeMessage::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.ReadAttributeMessage.deviceName)
}
#endif
inline void ReadAttributeMessage::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.ReadAttributeMessage.deviceName)
}
inline void ReadAttributeMessage::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.ReadAttributeMessage.deviceName)
}
inline ::std::string* ReadAttributeMessage::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.ReadAttributeMessage.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* ReadAttributeMessage::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.ReadAttributeMessage.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void ReadAttributeMessage::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.ReadAttributeMessage.deviceName)
}

// string attributeName = 2;
inline void ReadAttributeMessage::clear_attributename() {
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& ReadAttributeMessage::attributename() const {
  // @@protoc_insertion_point(field_get:mascot.ReadAttributeMessage.attributeName)
  return attributename_.GetNoArena();
}
inline void ReadAttributeMessage::set_attributename(const ::std::string& value) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.ReadAttributeMessage.attributeName)
}
#if LANG_CXX11
inline void ReadAttributeMessage::set_attributename(::std::string&& value) {
  
  attributename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.ReadAttributeMessage.attributeName)
}
#endif
inline void ReadAttributeMessage::set_attributename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.ReadAttributeMessage.attributeName)
}
inline void ReadAttributeMessage::set_attributename(const char* value, size_t size) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.ReadAttributeMessage.attributeName)
}
inline ::std::string* ReadAttributeMessage::mutable_attributename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.ReadAttributeMessage.attributeName)
  return attributename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* ReadAttributeMessage::release_attributename() {
  // @@protoc_insertion_point(field_release:mascot.ReadAttributeMessage.attributeName)
  
  return attributename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void ReadAttributeMessage::set_allocated_attributename(::std::string* attributename) {
  if (attributename != NULL) {
    
  } else {
    
  }
  attributename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), attributename);
  // @@protoc_insertion_point(field_set_allocated:mascot.ReadAttributeMessage.attributeName)
}

// -------------------------------------------------------------------

// ReadAttributeReply

// bool success = 1;
inline void ReadAttributeReply::clear_success() {
  success_ = false;
}
inline bool ReadAttributeReply::success() const {
  // @@protoc_insertion_point(field_get:mascot.ReadAttributeReply.success)
  return success_;
}
inline void ReadAttributeReply::set_success(bool value) {
  
  success_ = value;
  // @@protoc_insertion_point(field_set:mascot.ReadAttributeReply.success)
}

// .mascot.Error error = 2;
inline bool ReadAttributeReply::has_error() const {
  return this != internal_default_instance() && error_ != NULL;
}
inline const ::mascot::Error& ReadAttributeReply::error() const {
  const ::mascot::Error* p = error_;
  // @@protoc_insertion_point(field_get:mascot.ReadAttributeReply.error)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::Error*>(
      &::mascot::_Error_default_instance_);
}
inline ::mascot::Error* ReadAttributeReply::release_error() {
  // @@protoc_insertion_point(field_release:mascot.ReadAttributeReply.error)
  
  ::mascot::Error* temp = error_;
  error_ = NULL;
  return temp;
}
inline ::mascot::Error* ReadAttributeReply::mutable_error() {
  
  if (error_ == NULL) {
    error_ = new ::mascot::Error;
  }
  // @@protoc_insertion_point(field_mutable:mascot.ReadAttributeReply.error)
  return error_;
}
inline void ReadAttributeReply::set_allocated_error(::mascot::Error* error) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(error_);
  }
  if (error) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      error = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, error, submessage_arena);
    }
    
  } else {
    
  }
  error_ = error;
  // @@protoc_insertion_point(field_set_allocated:mascot.ReadAttributeReply.error)
}

// .mascot.DeviceAttribute data = 3;
inline bool ReadAttributeReply::has_data() const {
  return this != internal_default_instance() && data_ != NULL;
}
inline void ReadAttributeReply::clear_data() {
  if (GetArenaNoVirtual() == NULL && data_ != NULL) {
    delete data_;
  }
  data_ = NULL;
}
inline const ::mascot::DeviceAttribute& ReadAttributeReply::data() const {
  const ::mascot::DeviceAttribute* p = data_;
  // @@protoc_insertion_point(field_get:mascot.ReadAttributeReply.data)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::DeviceAttribute*>(
      &::mascot::_DeviceAttribute_default_instance_);
}
inline ::mascot::DeviceAttribute* ReadAttributeReply::release_data() {
  // @@protoc_insertion_point(field_release:mascot.ReadAttributeReply.data)
  
  ::mascot::DeviceAttribute* temp = data_;
  data_ = NULL;
  return temp;
}
inline ::mascot::DeviceAttribute* ReadAttributeReply::mutable_data() {
  
  if (data_ == NULL) {
    data_ = new ::mascot::DeviceAttribute;
  }
  // @@protoc_insertion_point(field_mutable:mascot.ReadAttributeReply.data)
  return data_;
}
inline void ReadAttributeReply::set_allocated_data(::mascot::DeviceAttribute* data) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete data_;
  }
  if (data) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      data = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, data, submessage_arena);
    }
    
  } else {
    
  }
  data_ = data;
  // @@protoc_insertion_point(field_set_allocated:mascot.ReadAttributeReply.data)
}

// -------------------------------------------------------------------

// DeviceAttribute

// .mascot.AttrDataFormat data_format = 1;
inline void DeviceAttribute::clear_data_format() {
  data_format_ = 0;
}
inline ::mascot::AttrDataFormat DeviceAttribute::data_format() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.data_format)
  return static_cast< ::mascot::AttrDataFormat >(data_format_);
}
inline void DeviceAttribute::set_data_format(::mascot::AttrDataFormat value) {
  
  data_format_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.data_format)
}

// int64 dim_x = 2;
inline void DeviceAttribute::clear_dim_x() {
  dim_x_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 DeviceAttribute::dim_x() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.dim_x)
  return dim_x_;
}
inline void DeviceAttribute::set_dim_x(::google::protobuf::int64 value) {
  
  dim_x_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.dim_x)
}

// int64 dim_y = 3;
inline void DeviceAttribute::clear_dim_y() {
  dim_y_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 DeviceAttribute::dim_y() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.dim_y)
  return dim_y_;
}
inline void DeviceAttribute::set_dim_y(::google::protobuf::int64 value) {
  
  dim_y_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.dim_y)
}

// bool has_failed = 4;
inline void DeviceAttribute::clear_has_failed() {
  has_failed_ = false;
}
inline bool DeviceAttribute::has_failed() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.has_failed)
  return has_failed_;
}
inline void DeviceAttribute::set_has_failed(bool value) {
  
  has_failed_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.has_failed)
}

// bool is_empty = 5;
inline void DeviceAttribute::clear_is_empty() {
  is_empty_ = false;
}
inline bool DeviceAttribute::is_empty() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.is_empty)
  return is_empty_;
}
inline void DeviceAttribute::set_is_empty(bool value) {
  
  is_empty_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.is_empty)
}

// string name = 6;
inline void DeviceAttribute::clear_name() {
  name_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& DeviceAttribute::name() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.name)
  return name_.GetNoArena();
}
inline void DeviceAttribute::set_name(const ::std::string& value) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.name)
}
#if LANG_CXX11
inline void DeviceAttribute::set_name(::std::string&& value) {
  
  name_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceAttribute.name)
}
#endif
inline void DeviceAttribute::set_name(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.DeviceAttribute.name)
}
inline void DeviceAttribute::set_name(const char* value, size_t size) {
  
  name_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceAttribute.name)
}
inline ::std::string* DeviceAttribute::mutable_name() {
  
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttribute.name)
  return name_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* DeviceAttribute::release_name() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttribute.name)
  
  return name_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void DeviceAttribute::set_allocated_name(::std::string* name) {
  if (name != NULL) {
    
  } else {
    
  }
  name_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), name);
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttribute.name)
}

// int64 nb_read = 7;
inline void DeviceAttribute::clear_nb_read() {
  nb_read_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 DeviceAttribute::nb_read() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.nb_read)
  return nb_read_;
}
inline void DeviceAttribute::set_nb_read(::google::protobuf::int64 value) {
  
  nb_read_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.nb_read)
}

// int64 nb_written = 8;
inline void DeviceAttribute::clear_nb_written() {
  nb_written_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 DeviceAttribute::nb_written() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.nb_written)
  return nb_written_;
}
inline void DeviceAttribute::set_nb_written(::google::protobuf::int64 value) {
  
  nb_written_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.nb_written)
}

// .mascot.AttrQuality quality = 9;
inline void DeviceAttribute::clear_quality() {
  quality_ = 0;
}
inline ::mascot::AttrQuality DeviceAttribute::quality() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.quality)
  return static_cast< ::mascot::AttrQuality >(quality_);
}
inline void DeviceAttribute::set_quality(::mascot::AttrQuality value) {
  
  quality_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.quality)
}

// .mascot.AttributeDimension r_dimension = 10;
inline bool DeviceAttribute::has_r_dimension() const {
  return this != internal_default_instance() && r_dimension_ != NULL;
}
inline void DeviceAttribute::clear_r_dimension() {
  if (GetArenaNoVirtual() == NULL && r_dimension_ != NULL) {
    delete r_dimension_;
  }
  r_dimension_ = NULL;
}
inline const ::mascot::AttributeDimension& DeviceAttribute::r_dimension() const {
  const ::mascot::AttributeDimension* p = r_dimension_;
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.r_dimension)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::AttributeDimension*>(
      &::mascot::_AttributeDimension_default_instance_);
}
inline ::mascot::AttributeDimension* DeviceAttribute::release_r_dimension() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttribute.r_dimension)
  
  ::mascot::AttributeDimension* temp = r_dimension_;
  r_dimension_ = NULL;
  return temp;
}
inline ::mascot::AttributeDimension* DeviceAttribute::mutable_r_dimension() {
  
  if (r_dimension_ == NULL) {
    r_dimension_ = new ::mascot::AttributeDimension;
  }
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttribute.r_dimension)
  return r_dimension_;
}
inline void DeviceAttribute::set_allocated_r_dimension(::mascot::AttributeDimension* r_dimension) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete r_dimension_;
  }
  if (r_dimension) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      r_dimension = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, r_dimension, submessage_arena);
    }
    
  } else {
    
  }
  r_dimension_ = r_dimension;
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttribute.r_dimension)
}

// .mascot.TimeVal time = 11;
inline bool DeviceAttribute::has_time() const {
  return this != internal_default_instance() && time_ != NULL;
}
inline void DeviceAttribute::clear_time() {
  if (GetArenaNoVirtual() == NULL && time_ != NULL) {
    delete time_;
  }
  time_ = NULL;
}
inline const ::mascot::TimeVal& DeviceAttribute::time() const {
  const ::mascot::TimeVal* p = time_;
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.time)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::TimeVal*>(
      &::mascot::_TimeVal_default_instance_);
}
inline ::mascot::TimeVal* DeviceAttribute::release_time() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttribute.time)
  
  ::mascot::TimeVal* temp = time_;
  time_ = NULL;
  return temp;
}
inline ::mascot::TimeVal* DeviceAttribute::mutable_time() {
  
  if (time_ == NULL) {
    time_ = new ::mascot::TimeVal;
  }
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttribute.time)
  return time_;
}
inline void DeviceAttribute::set_allocated_time(::mascot::TimeVal* time) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete time_;
  }
  if (time) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      time = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, time, submessage_arena);
    }
    
  } else {
    
  }
  time_ = time;
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttribute.time)
}

// .mascot.CmdArgType type = 12;
inline void DeviceAttribute::clear_type() {
  type_ = 0;
}
inline ::mascot::CmdArgType DeviceAttribute::type() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.type)
  return static_cast< ::mascot::CmdArgType >(type_);
}
inline void DeviceAttribute::set_type(::mascot::CmdArgType value) {
  
  type_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.type)
}

// .mascot.AttributeValue value = 13;
inline bool DeviceAttribute::has_value() const {
  return this != internal_default_instance() && value_ != NULL;
}
inline const ::mascot::AttributeValue& DeviceAttribute::value() const {
  const ::mascot::AttributeValue* p = value_;
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.value)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::AttributeValue*>(
      &::mascot::_AttributeValue_default_instance_);
}
inline ::mascot::AttributeValue* DeviceAttribute::release_value() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttribute.value)
  
  ::mascot::AttributeValue* temp = value_;
  value_ = NULL;
  return temp;
}
inline ::mascot::AttributeValue* DeviceAttribute::mutable_value() {
  
  if (value_ == NULL) {
    value_ = new ::mascot::AttributeValue;
  }
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttribute.value)
  return value_;
}
inline void DeviceAttribute::set_allocated_value(::mascot::AttributeValue* value) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(value_);
  }
  if (value) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      value = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, value, submessage_arena);
    }
    
  } else {
    
  }
  value_ = value;
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttribute.value)
}

// int64 w_dim_x = 14;
inline void DeviceAttribute::clear_w_dim_x() {
  w_dim_x_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 DeviceAttribute::w_dim_x() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.w_dim_x)
  return w_dim_x_;
}
inline void DeviceAttribute::set_w_dim_x(::google::protobuf::int64 value) {
  
  w_dim_x_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.w_dim_x)
}

// int64 w_dim_y = 15;
inline void DeviceAttribute::clear_w_dim_y() {
  w_dim_y_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 DeviceAttribute::w_dim_y() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.w_dim_y)
  return w_dim_y_;
}
inline void DeviceAttribute::set_w_dim_y(::google::protobuf::int64 value) {
  
  w_dim_y_ = value;
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.w_dim_y)
}

// .mascot.AttributeDimension w_dimension = 16;
inline bool DeviceAttribute::has_w_dimension() const {
  return this != internal_default_instance() && w_dimension_ != NULL;
}
inline void DeviceAttribute::clear_w_dimension() {
  if (GetArenaNoVirtual() == NULL && w_dimension_ != NULL) {
    delete w_dimension_;
  }
  w_dimension_ = NULL;
}
inline const ::mascot::AttributeDimension& DeviceAttribute::w_dimension() const {
  const ::mascot::AttributeDimension* p = w_dimension_;
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.w_dimension)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::AttributeDimension*>(
      &::mascot::_AttributeDimension_default_instance_);
}
inline ::mascot::AttributeDimension* DeviceAttribute::release_w_dimension() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttribute.w_dimension)
  
  ::mascot::AttributeDimension* temp = w_dimension_;
  w_dimension_ = NULL;
  return temp;
}
inline ::mascot::AttributeDimension* DeviceAttribute::mutable_w_dimension() {
  
  if (w_dimension_ == NULL) {
    w_dimension_ = new ::mascot::AttributeDimension;
  }
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttribute.w_dimension)
  return w_dimension_;
}
inline void DeviceAttribute::set_allocated_w_dimension(::mascot::AttributeDimension* w_dimension) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete w_dimension_;
  }
  if (w_dimension) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      w_dimension = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, w_dimension, submessage_arena);
    }
    
  } else {
    
  }
  w_dimension_ = w_dimension;
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttribute.w_dimension)
}

// string w_value = 17;
inline void DeviceAttribute::clear_w_value() {
  w_value_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& DeviceAttribute::w_value() const {
  // @@protoc_insertion_point(field_get:mascot.DeviceAttribute.w_value)
  return w_value_.GetNoArena();
}
inline void DeviceAttribute::set_w_value(const ::std::string& value) {
  
  w_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.DeviceAttribute.w_value)
}
#if LANG_CXX11
inline void DeviceAttribute::set_w_value(::std::string&& value) {
  
  w_value_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.DeviceAttribute.w_value)
}
#endif
inline void DeviceAttribute::set_w_value(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  w_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.DeviceAttribute.w_value)
}
inline void DeviceAttribute::set_w_value(const char* value, size_t size) {
  
  w_value_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.DeviceAttribute.w_value)
}
inline ::std::string* DeviceAttribute::mutable_w_value() {
  
  // @@protoc_insertion_point(field_mutable:mascot.DeviceAttribute.w_value)
  return w_value_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* DeviceAttribute::release_w_value() {
  // @@protoc_insertion_point(field_release:mascot.DeviceAttribute.w_value)
  
  return w_value_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void DeviceAttribute::set_allocated_w_value(::std::string* w_value) {
  if (w_value != NULL) {
    
  } else {
    
  }
  w_value_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), w_value);
  // @@protoc_insertion_point(field_set_allocated:mascot.DeviceAttribute.w_value)
}

// -------------------------------------------------------------------

// WriteAttributeMessage

// string deviceName = 1;
inline void WriteAttributeMessage::clear_devicename() {
  devicename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& WriteAttributeMessage::devicename() const {
  // @@protoc_insertion_point(field_get:mascot.WriteAttributeMessage.deviceName)
  return devicename_.GetNoArena();
}
inline void WriteAttributeMessage::set_devicename(const ::std::string& value) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.WriteAttributeMessage.deviceName)
}
#if LANG_CXX11
inline void WriteAttributeMessage::set_devicename(::std::string&& value) {
  
  devicename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.WriteAttributeMessage.deviceName)
}
#endif
inline void WriteAttributeMessage::set_devicename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.WriteAttributeMessage.deviceName)
}
inline void WriteAttributeMessage::set_devicename(const char* value, size_t size) {
  
  devicename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.WriteAttributeMessage.deviceName)
}
inline ::std::string* WriteAttributeMessage::mutable_devicename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.WriteAttributeMessage.deviceName)
  return devicename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* WriteAttributeMessage::release_devicename() {
  // @@protoc_insertion_point(field_release:mascot.WriteAttributeMessage.deviceName)
  
  return devicename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void WriteAttributeMessage::set_allocated_devicename(::std::string* devicename) {
  if (devicename != NULL) {
    
  } else {
    
  }
  devicename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), devicename);
  // @@protoc_insertion_point(field_set_allocated:mascot.WriteAttributeMessage.deviceName)
}

// string attributeName = 2;
inline void WriteAttributeMessage::clear_attributename() {
  attributename_.ClearToEmptyNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline const ::std::string& WriteAttributeMessage::attributename() const {
  // @@protoc_insertion_point(field_get:mascot.WriteAttributeMessage.attributeName)
  return attributename_.GetNoArena();
}
inline void WriteAttributeMessage::set_attributename(const ::std::string& value) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), value);
  // @@protoc_insertion_point(field_set:mascot.WriteAttributeMessage.attributeName)
}
#if LANG_CXX11
inline void WriteAttributeMessage::set_attributename(::std::string&& value) {
  
  attributename_.SetNoArena(
    &::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::move(value));
  // @@protoc_insertion_point(field_set_rvalue:mascot.WriteAttributeMessage.attributeName)
}
#endif
inline void WriteAttributeMessage::set_attributename(const char* value) {
  GOOGLE_DCHECK(value != NULL);
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), ::std::string(value));
  // @@protoc_insertion_point(field_set_char:mascot.WriteAttributeMessage.attributeName)
}
inline void WriteAttributeMessage::set_attributename(const char* value, size_t size) {
  
  attributename_.SetNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(),
      ::std::string(reinterpret_cast<const char*>(value), size));
  // @@protoc_insertion_point(field_set_pointer:mascot.WriteAttributeMessage.attributeName)
}
inline ::std::string* WriteAttributeMessage::mutable_attributename() {
  
  // @@protoc_insertion_point(field_mutable:mascot.WriteAttributeMessage.attributeName)
  return attributename_.MutableNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline ::std::string* WriteAttributeMessage::release_attributename() {
  // @@protoc_insertion_point(field_release:mascot.WriteAttributeMessage.attributeName)
  
  return attributename_.ReleaseNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited());
}
inline void WriteAttributeMessage::set_allocated_attributename(::std::string* attributename) {
  if (attributename != NULL) {
    
  } else {
    
  }
  attributename_.SetAllocatedNoArena(&::google::protobuf::internal::GetEmptyStringAlreadyInited(), attributename);
  // @@protoc_insertion_point(field_set_allocated:mascot.WriteAttributeMessage.attributeName)
}

// .mascot.AttributeValue value = 3;
inline bool WriteAttributeMessage::has_value() const {
  return this != internal_default_instance() && value_ != NULL;
}
inline const ::mascot::AttributeValue& WriteAttributeMessage::value() const {
  const ::mascot::AttributeValue* p = value_;
  // @@protoc_insertion_point(field_get:mascot.WriteAttributeMessage.value)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::AttributeValue*>(
      &::mascot::_AttributeValue_default_instance_);
}
inline ::mascot::AttributeValue* WriteAttributeMessage::release_value() {
  // @@protoc_insertion_point(field_release:mascot.WriteAttributeMessage.value)
  
  ::mascot::AttributeValue* temp = value_;
  value_ = NULL;
  return temp;
}
inline ::mascot::AttributeValue* WriteAttributeMessage::mutable_value() {
  
  if (value_ == NULL) {
    value_ = new ::mascot::AttributeValue;
  }
  // @@protoc_insertion_point(field_mutable:mascot.WriteAttributeMessage.value)
  return value_;
}
inline void WriteAttributeMessage::set_allocated_value(::mascot::AttributeValue* value) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(value_);
  }
  if (value) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      value = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, value, submessage_arena);
    }
    
  } else {
    
  }
  value_ = value;
  // @@protoc_insertion_point(field_set_allocated:mascot.WriteAttributeMessage.value)
}

// -------------------------------------------------------------------

// WriteReply

// bool success = 1;
inline void WriteReply::clear_success() {
  success_ = false;
}
inline bool WriteReply::success() const {
  // @@protoc_insertion_point(field_get:mascot.WriteReply.success)
  return success_;
}
inline void WriteReply::set_success(bool value) {
  
  success_ = value;
  // @@protoc_insertion_point(field_set:mascot.WriteReply.success)
}

// .mascot.Error error = 2;
inline bool WriteReply::has_error() const {
  return this != internal_default_instance() && error_ != NULL;
}
inline const ::mascot::Error& WriteReply::error() const {
  const ::mascot::Error* p = error_;
  // @@protoc_insertion_point(field_get:mascot.WriteReply.error)
  return p != NULL ? *p : *reinterpret_cast<const ::mascot::Error*>(
      &::mascot::_Error_default_instance_);
}
inline ::mascot::Error* WriteReply::release_error() {
  // @@protoc_insertion_point(field_release:mascot.WriteReply.error)
  
  ::mascot::Error* temp = error_;
  error_ = NULL;
  return temp;
}
inline ::mascot::Error* WriteReply::mutable_error() {
  
  if (error_ == NULL) {
    error_ = new ::mascot::Error;
  }
  // @@protoc_insertion_point(field_mutable:mascot.WriteReply.error)
  return error_;
}
inline void WriteReply::set_allocated_error(::mascot::Error* error) {
  ::google::protobuf::Arena* message_arena = GetArenaNoVirtual();
  if (message_arena == NULL) {
    delete reinterpret_cast< ::google::protobuf::MessageLite*>(error_);
  }
  if (error) {
    ::google::protobuf::Arena* submessage_arena = NULL;
    if (message_arena != submessage_arena) {
      error = ::google::protobuf::internal::GetOwnedMessage(
          message_arena, error, submessage_arena);
    }
    
  } else {
    
  }
  error_ = error;
  // @@protoc_insertion_point(field_set_allocated:mascot.WriteReply.error)
}

// -------------------------------------------------------------------

// AttributeDimension

// int64 dim_x = 1;
inline void AttributeDimension::clear_dim_x() {
  dim_x_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 AttributeDimension::dim_x() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeDimension.dim_x)
  return dim_x_;
}
inline void AttributeDimension::set_dim_x(::google::protobuf::int64 value) {
  
  dim_x_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeDimension.dim_x)
}

// int64 dim_y = 2;
inline void AttributeDimension::clear_dim_y() {
  dim_y_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 AttributeDimension::dim_y() const {
  // @@protoc_insertion_point(field_get:mascot.AttributeDimension.dim_y)
  return dim_y_;
}
inline void AttributeDimension::set_dim_y(::google::protobuf::int64 value) {
  
  dim_y_ = value;
  // @@protoc_insertion_point(field_set:mascot.AttributeDimension.dim_y)
}

// -------------------------------------------------------------------

// TimeVal

// int64 tv_nsec = 1;
inline void TimeVal::clear_tv_nsec() {
  tv_nsec_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 TimeVal::tv_nsec() const {
  // @@protoc_insertion_point(field_get:mascot.TimeVal.tv_nsec)
  return tv_nsec_;
}
inline void TimeVal::set_tv_nsec(::google::protobuf::int64 value) {
  
  tv_nsec_ = value;
  // @@protoc_insertion_point(field_set:mascot.TimeVal.tv_nsec)
}

// int64 tv_sec = 2;
inline void TimeVal::clear_tv_sec() {
  tv_sec_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 TimeVal::tv_sec() const {
  // @@protoc_insertion_point(field_get:mascot.TimeVal.tv_sec)
  return tv_sec_;
}
inline void TimeVal::set_tv_sec(::google::protobuf::int64 value) {
  
  tv_sec_ = value;
  // @@protoc_insertion_point(field_set:mascot.TimeVal.tv_sec)
}

// int64 tv_usec = 3;
inline void TimeVal::clear_tv_usec() {
  tv_usec_ = GOOGLE_LONGLONG(0);
}
inline ::google::protobuf::int64 TimeVal::tv_usec() const {
  // @@protoc_insertion_point(field_get:mascot.TimeVal.tv_usec)
  return tv_usec_;
}
inline void TimeVal::set_tv_usec(::google::protobuf::int64 value) {
  
  tv_usec_ = value;
  // @@protoc_insertion_point(field_set:mascot.TimeVal.tv_usec)
}

#ifdef __GNUC__
  #pragma GCC diagnostic pop
#endif  // __GNUC__
// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------

// -------------------------------------------------------------------


// @@protoc_insertion_point(namespace_scope)

}  // namespace mascot

// @@protoc_insertion_point(global_scope)

#endif  // PROTOBUF_attributes_2eproto__INCLUDED
